﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using System.Linq;

public class Square : FlatLandObject
{

    public LineRenderer pathRenderer; // About drawing paths.
    public List<Vector3> pathList = new List<Vector3>();
    private float _zPosition => transform.position.z;

    private void Awake()
    {
        _ResetPaths();
    }

    private void Update()
    {
        if (Input.GetMouseButtonDown(1))
        {
            RaycastHit hit;
            var ray = Camera.main.ScreenPointToRay(Input.mousePosition);

            if (Physics.Raycast(ray, out hit))
            {
                if (Input.GetKey(KeyCode.LeftShift))
                {
                    Debug.Log("asdf");
                    _DrawMorePath(hit.point);
                }
                else
                {
                    _DrawOnePath(hit.point);
                }
            }
        }
    }

    private void _DrawOnePath(Vector3 point)
    {
        _ResetPaths();
        point.z = _zPosition;
        pathList[0] = transform.position;
        pathList[1] = point;
        pathRenderer.SetPositions(pathList.ToArray());
    }

    private void _ResetPaths()
    {
        pathRenderer.positionCount = 2;
        pathList.Clear();
        pathList.Add(transform.position);
        pathList.Add(new Vector3(0, 0, _zPosition));
        pathRenderer.SetPositions(pathList.ToArray());
    }

    private void _DrawMorePath(Vector3 point)
    {
        point.z = _zPosition;
        pathList.Add(point);
        pathRenderer.positionCount = pathList.Count();
        pathRenderer.SetPositions(pathList.ToArray());
    }
}
